import { createSlice } from '@reduxjs/toolkit'
import { ToastType } from '../types/toastType'

const initialState: ToastType = {
  type: null,
  message: '',
}

const alertReducer = createSlice({
  name: 'alert',
  initialState: initialState,
  reducers: {
    infoAlert: (state, payload) => {
      state.type = 'info'
      state.message = payload.payload.message
      state.colorTheme = payload.payload.colorTheme
      state.promise = undefined
      state.config = undefined
      state.icon = payload.payload.icon
    },
    errorAlert: (state, payload) => {
      state.type = 'error'
      state.message = payload.payload.message
      state.colorTheme = payload.payload.colorTheme
      state.promise = undefined
      state.config = undefined
      state.icon = payload.payload.icon
    },
    warningAlert: (state, payload) => {
      state.type = 'warning'
      state.message = payload.payload.message
      state.colorTheme = payload.payload.colorTheme
      state.promise = undefined
      state.config = undefined
      state.icon = payload.payload.icon
    },
    successAlert: (state, payload) => {
      state.type = 'success'
      state.message = payload.payload.message
      state.colorTheme = payload.payload.colorTheme
      state.promise = undefined
      state.config = undefined
      state.icon = payload.payload.icon
    },
    promiseAlert: (state, payload) => {
      state.type = 'promise'
      state.message = undefined
      state.promise = payload.payload.promise
      state.config = payload.payload.config
      state.colorTheme = payload.payload.colorTheme
      state.icon = payload.payload.icon
    }
  }
})

export const { infoAlert, errorAlert, successAlert, warningAlert, promiseAlert } = alertReducer.actions

export default alertReducer.reducer
